{ deprekages, pkgs, ... }:
{

  #
  # Git.
  #
  programs.git = {
    enable = true;
    lfs.enable = true;

    # Note: we no longer set a name, here, forcing us to choose our e-mail and username
    # on a per-project basis.

    # Proide the difftastic command.
    difftastic.enable = true;

    extraConfig = {
      # Use main as our branch names.
      init.defaultBranch = "main";

      #
      # Use mergiraf.
      #

      # Set up the merge driver...
      merge.mergiraf = {
        name = "mergiraf";
        driver = "${deprekages.mergiraf}/bin/mergiraf merge --git %O %A %B -s %S -x %X -y %Y -p %P";
      };

      # ... and set when to use it.
      core.attributesFile = toString (
        pkgs.writeText ".gitattributes" ''
          				*.java merge=mergiraf
                  *.rs merge=mergiraf
                  *.go merge=mergiraf
                  *.js merge=mergiraf
                  *.jsx merge=mergiraf
                  *.json merge=mergiraf
                  *.yml merge=mergiraf
                  *.yaml merge=mergiraf
                  *.html merge=mergiraf
                  *.htm merge=mergiraf
                  *.xhtml merge=mergiraf
                  *.xml merge=mergiraf
                  *.c merge=mergiraf
                  *.cc merge=mergiraf
                  *.h merge=mergiraf
                  *.cpp merge=mergiraf
                  *.hpp merge=mergiraf
                  *.cs merge=mergiraf
                  *.dart merge=mergiraf
            		''
      );

    };
  };

}
