#
# General nix settings.
#
# vim: et:ts=2:sw=2:
#
{ config, ... }:
{

  nix = {
    settings = {

      # Use nix, lix, and our local cache.
      substituters = [
        "https://cache.nixos.org"
        "https://cache.lix.systems"
        "https://niri.cachix.org"
      ];
      trusted-public-keys = [
        "cache.nixos.org-1:6NCHdD59X431o0gWypbMrAURkbJ16ZPMQFGspcDShjY="
        "cache.lix.systems:aBnZUw8zA7H35Cz2RyKFVs3H4PlGTLawyY5KRbvJR8o="
        "niri.cachix.org-1:Wv0OmO7PsuocRKzfDoJ3mulSl7Z6oezYhGhR+3W2964="
      ];

    };

    # For non-trailblazer machines, allow building on Trailblazer.
    distributedBuilds = !(config.networking.hostName == "trailblazer");
    buildMachines =
      if config.nix.distributedBuilds then
        [
          {
            system = "x86_64-linux";
            protocol = "ssh";

            hostName = "trailblazer.kate.ts.polytheon.org";

            sshUser = "deprekated";
            sshKey = "/home/deprekated/.ssh/id_ed25519";

            maxJobs = 24;
            speedFactor = 25;
          }
        ]
      else
        [ ];
  };

  nixpkgs.config.permittedInsecurePackages = [
    "olm-3.2.16"
  ];

}
