#
# Dotfile specifics for Miko
#

# Path
# Note: lower in the list = higher priority
PATH_ADDS = [
  "/usr/local/opt/coreutils/libexec/gnubin",
  "/usr/local/opt/findutils/libexec/gnubin",
  "/usr/local/bin",
  "/usr/local/opt/gnu-sed/libexec/gnubin",
  "/usr/local/bin",
  "/Users/deprekated/.cargo/bin",
  "/usr/local/sbin",
  "/usr/local/bin",
  "/usr/local/Cellar/ruby/2.3.3/bin",
  "/usr/local/opt/llvm/bin",
  "/Users/deprekated/.bin/",
  "/Users/deprekated/.local/bin/",
  "/usr/local/opt/e2fsprogs/sbin",
  "/usr/local/opt/grep/libexec/gnubin",
  "/Users/deprekated/Library/Python/3.9/bin",
  "/etc/profiles/per-user/deprekated/bin/",
  "/run/current-system/sw/bin"
]


# Aliases
aliases['ls'] = 'eza -gb'
aliases['tree'] = 'eza --tree'

aliases['lsusb'] = 'grc -c lsusb.conf lsusb'
aliases['lsnotes'] = "eza --tree '~/Dropbox/Apps/GoodNotes 5/GoodNotes/'"

# Helper to make every system have the same rebuild.
aliases['rebuild'] = 'darwin-rebuild --flake ~/dotfiles'

# Python
$PYTHONPATH=[
	'/Applications/Binary Ninja.app/Contents/Resources/python',
	'/Users/deprekated/Projects/amaranth/amaranth',
	'/Users/deprekated/Projects/luna',
	'/Users/deprekated/Projects/amaranth/amaranth-boards',
	'/Users/deprekated/Projects/t5/t5gw'
]


# Smartcard auth
$GPG_TTY=$(tty).strip()
try:
    $ORIGINAL_SSH_AUTH_SOCK=$SSH_AUTH_SOCK
except:
	pass

if 'SSH_AUTH_SOCK' not in ${...} or $SSH_AUTH_SOCK.startswith('/private'):
	$SSH_AUTH_SOCK=$(/usr/local/MacGPG2/bin/gpgconf --list-dirs agent-ssh-socket).strip()
	/usr/local/MacGPG2/bin/gpgconf --launch gpg-agent


# Make scopehal-apps work on macOS.
$VK_ICD_FILENAMES="/Users/deprekated/VulkanSDK/1.3.231.1/macOS/share/vulkan/icd.d/MoltenVK_icd.json"

# Nix
source-bash '/nix/var/nix/profiles/default/etc/profile.d/nix-daemon.sh'
source-bash '/etc/static/bashrc'
source-bash '/nix/var/nix/profiles/per-user/deprekated/profile/etc/profile.d/hm-session-vars.sh'

# Temporary hack.
$TERMINFO_DIRS = [ "/usr/share/terminfo", "/Users/deprekated/.terminfo"]
